
ChiliProject - Bug # 748: ChiliProject::VERSION.revision doesn't capture error output

Status: Closed Priority: Normal
Author: Pete Deffendol Category: Refactoring
Created: 2011-12-02 Assignee: Felix Schäfer
Updated: 2011-12-15 Due date:
Remote issue URL:
Affected version: 2.5.0
Description: My production ChiliProject install is outputting an error in my Apache logs and when I run a rake task:

<pre>
fatal: Not a git repository (or any of the parent directories): .git
</pre>

Turns out, this is the culprit (from the Rails console):

<pre>
>> ChiliProject::VERSION.revision 
fatal: Not a git repository (or any of the parent directories): .git
=> nil
</pre>

And, in lib/chili_project/version.rb, starting at line 40:

<pre>
    def self.revision
      revision = `git rev-parse HEAD`
      if revision.present?
        revision.strip[0..8]
      else
        nil
      end
    end
</pre>

This doesn't manifest in development, because I'm working with a Git clone.  But in production, I deploy to a 
clean folder, so there is no repository to read.

The output of the backtick command (git rev-parse HEAD) needs to be captured and thrown away.

Associated revisions
2008-03-31 10:51 pm - Jean-Philippe Lang 
Add overflow:auto to the content div (closes #676, #748, #961).

git-svn-id: http://redmine.rubyforge.org/svn/trunk@1314 e93f8b46-1217-0410-a6f0-8f06a7374b81

2011-12-03 05:39 pm - Felix SchÃ¤fer 
[#748] Make ChiliProject::Version.revision more resilient

* Won't output errors when the ChiliProject git repo isn't there anymore,
* Works even if not invoked from the ChiliProject root directory,
* Moved the formatting logic to the git call.
2011-12-15 10:08 pm - Holger Just 
[#748] Use SCM commands to detect the revision

History
2011-12-02 06:08 am - Pete Deffendol
Using this works, but only on a Linux-type system:

`git rev-parse HEAD 2>/dev/null` 

2011-12-02 06:10 am - Felix Schäfer
- Target version set to 2.6.0

Thanks for the report. Did you use one of the packaged versions or did you "export" it from the git repository yourself?

2011-12-02 06:18 am - Pete Deffendol
Felix SchÃ¤fer wrote:
> Thanks for the report. Did you use one of the packaged versions or did you "export" it from the git repository yourself?

I'm exporting from a local clone of the official repository.  It's 2.5.0 with a few of our own modifications.

2011-12-03 04:41 pm - Felix Schäfer
- Assignee set to Felix Schäfer

- Category set to Refactoring

- Status changed from Open to Closed

I've corrected this issue and made the code more resilient in commit:d943efd, thanks for reporting!

2011-12-15 09:10 pm - Holger Just
I just updated your patch and made it use the git repository adapter. That way, we don't duplicate code and people can set the path to the git binary.

Commit in commit:611889f
